{--(02 aug 2000)----------------------------------------------------------------

                                  API for the
                      Sync/Async calls for Xaudio library.

                      Converted By Lars Peter Christiansen
                           home1.stofanet.dk/nitezhifter

    This product is FreeWare and can be freely distributed. It cannot be used
    for commercial purposes without the authors approval!

-------------------------------------------------------------------------------}
unit xaudio;

interface

Const
  XADLL = 'xaudio.dll';

{-------------------------------------------------------------------------------
       API ID's
-------------------------------------------------------------------------------}
  XA_API_ID_SYNC = 1;
  XA_API_ID_ASYNC= 2;


{-------------------------------------------------------------------------------
       Error codes
-------------------------------------------------------------------------------}
  XA_SUCCES = 0;
  XA_FAILURE= -1;



//* general error codes */
  XA_ERROR_BASE_GENERAL        =      (-100);
  XA_ERROR_OUT_OF_MEMORY       =      (XA_ERROR_BASE_GENERAL - 0);
  XA_ERROR_INVALID_PARAMETERS  =      (XA_ERROR_BASE_GENERAL - 1);
  XA_ERROR_INTERNAL            =      (XA_ERROR_BASE_GENERAL - 2);
  XA_ERROR_TIMEOUT             =      (XA_ERROR_BASE_GENERAL - 3);
  XA_ERROR_VERSION_EXPIRED     =      (XA_ERROR_BASE_GENERAL - 4);



// network error codes
  XA_ERROR_BASE_NETWORK        =      (-200);
  XA_ERROR_CONNECT_TIMEOUT     =      (XA_ERROR_BASE_NETWORK -  0);
  XA_ERROR_CONNECT_FAILED      =      (XA_ERROR_BASE_NETWORK -  1);
  XA_ERROR_CONNECTION_REFUSED  =      (XA_ERROR_BASE_NETWORK -  2);
  XA_ERROR_ACCEPT_FAILED       =      (XA_ERROR_BASE_NETWORK -  3);
  XA_ERROR_LISTEN_FAILED       =      (XA_ERROR_BASE_NETWORK -  4);
  XA_ERROR_SOCKET_FAILED       =      (XA_ERROR_BASE_NETWORK -  5);
  XA_ERROR_SOCKET_CLOSED       =      (XA_ERROR_BASE_NETWORK -  6);
  XA_ERROR_BIND_FAILED         =      (XA_ERROR_BASE_NETWORK -  7);
  XA_ERROR_HOST_UNKNOWN        =      (XA_ERROR_BASE_NETWORK -  8);
  XA_ERROR_HTTP_INVALID_REPLY  =      (XA_ERROR_BASE_NETWORK -  9);
  XA_ERROR_HTTP_ERROR_REPLY    =      (XA_ERROR_BASE_NETWORK - 10);
  XA_ERROR_HTTP_FAILURE        =      (XA_ERROR_BASE_NETWORK - 11);
  XA_ERROR_FTP_INVALID_REPLY   =      (XA_ERROR_BASE_NETWORK - 12);
  XA_ERROR_FTP_ERROR_REPLY     =      (XA_ERROR_BASE_NETWORK - 13);
  XA_ERROR_FTP_FAILURE         =      (XA_ERROR_BASE_NETWORK - 14);

// control error codes
  XA_ERROR_BASE_CONTROL      =        (-300);
  XA_ERROR_PIPE_FAILED       =        (XA_ERROR_BASE_CONTROL - 0);
  XA_ERROR_FORK_FAILED       =        (XA_ERROR_BASE_CONTROL - 1);
  XA_ERROR_SELECT_FAILED     =        (XA_ERROR_BASE_CONTROL - 2);
  XA_ERROR_PIPE_CLOSED       =        (XA_ERROR_BASE_CONTROL - 3);
  XA_ERROR_PIPE_READ_FAILED  =        (XA_ERROR_BASE_CONTROL - 4);
  XA_ERROR_PIPE_WRITE_FAILED =        (XA_ERROR_BASE_CONTROL - 5);
  XA_ERROR_INVALID_MESSAGE   =        (XA_ERROR_BASE_CONTROL - 6);
  XA_ERROR_CIRQ_FULL         =        (XA_ERROR_BASE_CONTROL - 7);
  XA_ERROR_POST_FAILED       =        (XA_ERROR_BASE_CONTROL - 8);

  XA_ERROR_BASE_URL               = -400;
  XA_ERROR_URL_UNSUPPORTED_SCHEME = XA_ERROR_BASE_URL - 0;
  XA_ERROR_URL_INVALID_SYNTAX     = XA_ERROR_BASE_URL - 1;

  XA_ERROR_BASE_IO = -500;
  XA_ERROR_open_FAILED       =         XA_ERROR_BASE_IO -  0;
  XA_ERROR_CLOSE_FAILED      =        (XA_ERROR_BASE_IO -  1);
  XA_ERROR_READ_FAILED       =        (XA_ERROR_BASE_IO -  2);
  XA_ERROR_WRITE_FAILED      =        (XA_ERROR_BASE_IO -  3);
  XA_ERROR_PERMISSION_DENIED =        (XA_ERROR_BASE_IO -  4);
  XA_ERROR_NO_DEVICE         =        (XA_ERROR_BASE_IO -  5);
  XA_ERROR_IOCTL_FAILED      =        (XA_ERROR_BASE_IO -  6);
  XA_ERROR_MODULE_NOT_FOUND  =        (XA_ERROR_BASE_IO -  7);
  XA_ERROR_UNSUPPORTED_INPUT =        (XA_ERROR_BASE_IO -  8);
  XA_ERROR_UNSUPPORTED_OUTPUT=        (XA_ERROR_BASE_IO -  9);
  XA_ERROR_UNSUPPORTED_FORMAT=        (XA_ERROR_BASE_IO - 10);
  XA_ERROR_DEVICE_BUSY       =        (XA_ERROR_BASE_IO - 11);
  XA_ERROR_NO_SUCH_DEVICE    =        (XA_ERROR_BASE_IO - 12);
  XA_ERROR_NO_SUCH_FILE      =        (XA_ERROR_BASE_IO - 13);
  XA_ERROR_INPUT_EOF         =         XA_ERROR_BASE_IO - 14;

  XA_ERROR_BASE_BITSTREAM = -600;
  XA_ERROR_INVALID_FRAME = XA_ERROR_BASE_BITSTREAM - 0;

  XA_ERROR_BASE_DYNLINK              = -700;
  XA_ERROR_DLL_NOT_FOUND             = XA_ERROR_BASE_DYNLINK -0;
  XA_ERROR_SYMBOL_NOT_FOUND          = XA_ERROR_BASE_DYNLINK -1;

  XA_ERROR_BASE_ENVIRONMENT          = -800;
  XA_ERROR_NO_SUCH_ENVIRONMENT       = XA_ERROR_BASE_ENVIRONMENT-0;
  XA_ERROR_ENVIRONMENT_TYPE_MISMATCH = XA_ERROR_BASE_ENVIRONMENT-1;

  // CONSTS FROM DECODER.H -----------------------------------------------------      // Consts from decoder.h

  XA_DECODER_INPUT_SEEKABLE                 = 1;
  XA_DECODER_DEVICE_HAS_MASTER_LEVEL_CONTROL= $000000001;
  XA_DECODER_DEVICE_HAS_PCM_LEVEL_CONTROL   = $000000002;
  XA_DECODER_DEVICE_HAS_BALANCE_CONTROL     = $000000004;
  XA_DECODER_DEVICE_HAS_LINE_OUT            = $000000008;
  XA_DECODER_DEVICE_HAS_SPEAKER_OUT         = $000000010;
  XA_DECODER_DEVICE_HAS_HEADPHONE_OUT       = $000000020;
  XA_DECODER_DEVICE_HAS_08_000_KHZ          = $000000040;
  XA_DECODER_DEVICE_HAS_11_025_KHZ          = $000000080;
  XA_DECODER_DEVICE_HAS_12_000_KHZ          = $000000100;
  XA_DECODER_DEVICE_HAS_16_000_KHZ          = $000000200;
  XA_DECODER_DEVICE_HAS_22_050_KHZ          = $000000400;
  XA_DECODER_DEVICE_HAS_24_000_KHZ          = $000000800;
  XA_DECODER_DEVICE_HAS_32_000_KHZ          = $000001000;
  XA_DECODER_DEVICE_HAS_44_100_KHZ          = $000002000;
  XA_DECODER_DEVICE_HAS_48_000_KHZ          = $000004000;
  XA_DECODER_DEVICE_HAS_8_BITS              = $000008000;
  XA_DECODER_DEVICE_HAS_MU_LAW              = $000010000;
  XA_DECODER_DEVICE_HAS_16_BITS             = $000020000;
  XA_DECODER_DEVICE_HAS_MUTE                = $000040000;
  XA_DECODER_DEVICE_HAS_RESET               = $000080000;
  XA_DECODER_DEVICE_HAS_PAUSE               = $000100000;
  XA_DECODER_DEVICE_HAS_DRAIN               = $000200000;
  XA_DECODER_DEVICE_HAS_BUFFER_STATUS       = $000400000;
  XA_DECODER_DEVICE_FREQUENCIES_OFFSET      = 6;
  XA_DECODER_DEVICE_FREQUENCIES_MASK        = $01FF;
  XA_DECODER_CONTROL_BPS                    = $00001;
  XA_DECODER_CONTROL_STEREO                 = $00002;
  XA_DECODER_CONTROL_SAMPLE_RATE            = $00004;
  XA_DECODER_CONTROL_MASTER_LEVEL           = $00008;
  XA_DECODER_CONTROL_PCM_LEVEL              = $00010;
  XA_DECODER_CONTROL_BALANCE                = $00020;
  XA_DECODER_CONTROL_PORTS                  = $00040;
  XA_DECODER_CONTROL_ALL_INFO               = $0007F;
  XA_DECODER_CONTROL_MUTE                   = $00080;
  XA_DECODER_CONTROL_UNMUTE                 = $00100;
  XA_DECODER_CONTROL_RESET                  = $00200;
  XA_DECODER_CONTROL_PAUSE                  = $00400;
  XA_DECODER_CONTROL_RESTART                = $00800;
  XA_DECODER_CONTROL_DRAIN                  = $01000;
  XA_DECODER_CONTROL_OUTPUT_LINE            = $001;
  XA_DECODER_CONTROL_OUTPUT_SPEAKER         = $002;
  XA_DECODER_CONTROL_OUTPUT_HEADPHONE       = $004;
  XA_DECODER_ENVIRONMENT_MAX_NAME_LENGTH    = 256 ;
  XA_DECODER_ENVIRONMENT_MAX_STRING_LENGTH  = 1024;
  XA_DECODER_INPUT_QUERY_MODULE_NAME        = $001;
  XA_DECODER_INPUT_QUERY_NB_DEVICES         = $002;
  XA_DECODER_INPUT_QUERY_DEVICE_NAME        = $004;
  XA_DECODER_INPUT_QUERY_NAME_IS_GENERIC    = $001;
  XA_DECODER_INPUT_QUERY_DEVICE_IS_DEFAULT  = $002;
  XA_DECODER_OUTPUT_QUERY_MODULE_NAME       = $001;
  XA_DECODER_OUTPUT_QUERY_NB_DEVICES        = $002;
  XA_DECODER_OUTPUT_QUERY_DEVICE_NAME       = $004;
  XA_DECODER_OUTPUT_QUERY_NAME_IS_GENERIC    =$001;
  XA_DECODER_OUTPUT_QUERY_DEVICE_IS_DEFAULT  =$002;
  XA_DECODER_OUTPUT_QUERY_DEVICE_IS_SHAREABLE=$004;
  XA_DECODER_MAX_NAME_LENGTH                 =255;
  XA_DECODER_MAX_DESCRIPTION_LENGTH          =255;
  XA_DECODER_INPUT_AUTOSELECT                =-1 ;
  XA_DECODER_OUTPUT_AUTOSELECT               =-1 ;
  XA_DECODER_INPUT_FILTER_FIRST              =-1 ;
  XA_DECODER_INPUT_FILTER_LAST               = 0 ;
  XA_DECODER_INPUT_FILTER_BY_NAME            =-2 ;
  XA_DECODER_OUTPUT_FILTER_FIRST             =-1 ;
  XA_DECODER_OUTPUT_FILTER_LAST              = 0 ;
  XA_DECODER_OUTPUT_FILTER_BY_NAME           =-2 ;
  XA_TIMECODE_FRACTIONS_PER_SECOND   =        100 ;
  XA_TIMECODE_FRACTIONS_PER_MINUTE   =     (100*60);
  XA_TIMECODE_FRACTIONS_PER_HOUR     =  (100*60*60);
  XA_DECODER_CODEC_QUALITY_HIGH      =         0 ;
  XA_DECODER_CODEC_QUALITY_MEDIUM    =         1 ;
  XA_DECODER_CODEC_QUALITY_LOW       =         2 ;
  XA_DECODER_EQUALIZER_NB_BANDS      =         32;
  XA_DECODER_FEEDBACK_NB_BANDS       =         32;

{-------------------------------------------------------------------------------

       TYPE DECLARATIONS

-------------------------------------------------------------------------------}
Type

// NOTIFICATION Functions and structs

  TXA_ErrorNotificationFunction =
    Procedure(client:pointer;souce,code:integer;message,reason:pchar);

  TXA_DebugNotificationFunction =
    procedure(client:pointer;source,level:integer;message,reason : pchar);

  TXA_ProgressNotificationFunction=
    procedure(client:pointer;source,code:integer;value:longword;message:pchar);

  TXA_EnvironmentCallback =
    Procedure(listener:pointer;name:pchar;value:pointer);

  TXA_NotificationClient = record
    Client : pointer;
    Notify_progress : TXA_ProgressNotificationFunction;
    Notify_debug : TXA_DebugNotificationFunction;
    Notify_error : TXA_ErrorNotificationFunction;
  end;

// forward declarations
  PXA_OutputModule = ^TXA_OutputModule;
  PXA_InputModule = ^TXA_InputModule;
  PXA_DecoderInfo = ^TXA_DecoderInfo;


// Time structs
  PXA_TimeCode=^TXA_TimeCode;
  TXA_TimeCode = record
    h,m,s,f : integer;
  end;

  TXA_AbsoluteTime = record
    seconds,
    microseconds : Longword;
  end;


  TXA_IOState = ( XA_IO_STATE_CLOSED, XA_IO_STATE_OPEN );

// input structs

  PXA_InputModuleQuery = ^TXA_InputModuleQuery;
  TXA_InputModuleQuery = record
    index : integer;
    flags : Longword;
    name  : array [0..XA_DECODER_MAX_NAME_LENGTH-1] of char;
    Description :array [0..XA_DECODER_MAX_DESCRIPTION_LENGTH] of char;
  end;

  PXA_InputModuleClassInfo = ^TXA_InputModuleClassInfo;
  TXA_InputModuleClassInfo = record
    id : integer;
    global:pointer;
  end;

  TXA_InputModule = record
    input_module_probe : function(name:pchar):integer;
    input_module_query : function(Query:PXA_InputModuleQuery;Query_mask:Longword):integer;
    input_new          : function(input:pointer; name : pchar;class_info:PXA_InputModuleClassInfo;
                                  decoder:PXA_DecoderInfo):integer;
    input_delete,
    input_open,
    input_close : function(input:pointer):integer;
    input_read : function(input:pointer;buffer:pointer;n:longword):integer;
    input_seek : function(input:pointer;offset:longword):integer;
    input_get_caps,
    Input_Get_size :function(input:pointer):longword;
    input_send_message:Function(input:pointer;typ:integer;data:pointer;size:longword):integer;
  end;

  PXA_InputInfo = ^TXA_InputInfo;
  TXA_InputInfo = record
    state : TXA_IOState;
    caps,
    position,
    size,
    duration : Longword;
    device:pointer;
    module : PXA_InputModule;
    name : pchar;
  end;

  TXA_InputStreamInfo = record
    changed,
    level,
    layer,
    bitrate,
    frequency,
    mode : integer;
  end;


  PXA_StatusInfo=^TXA_Statusinfo;
  TXA_StatusInfo = record
    frame : Longword;
    Position:single;
    info : TXA_InputStreamInfo;
    timecode:TXA_Timecode;
  end;

// output

  PXA_outputstatus=^TXA_outputstatus;
  TXA_outputStatus = record
    delay:longword;
  end;


  PXA_OutputBufferInfo = ^TXA_OutputBufferInfo;
  TXA_OutputBufferInfo = record
    changed : integer;
    pcm_samples : pointer;
    size,
    bytes_per_sample:integer;
    stereo      : LongBool;
    sample_rate : integer;
    delay : Longword;
  end;

  PXA_OutputModuleClassinfo=^TXA_OutputModuleClassinfo;
  TXA_OutputModuleClassinfo = record
    id:integer;
    global:pointer;
  end;

  PXA_outputchannelsmode = ^TXA_outputchannelsmode;
  TXA_outputchannelsmode = ( XA_OUTPUT_STEREO,
                             XA_OUTPUT_MONO_LEFT,
                             XA_OUTPUT_MONO_RIGHT,
                             XA_OUTPUT_MONO_MIX );

  PXA_Outputinfo = ^TXA_outputinfo;
  TXA_outputinfo = record
    state : TXA_IOState;
    caps : Longword;
    Device : pointer;
    Module : PXA_OutputModule;
    name : Pchar;
  end;

  PXA_OutputControl=^TXA_OutputControl;
  TXA_OutputControl = record
    bytes_perSample,
    sample_rate,
    stereo,
    master_level,
    pcm_level,
    balance,
    ports :integer;
  end;

  TXA_OutputmoduleQuery = record
    index :integer;
    flags: Longword;
    name : array[0..XA_DECODER_MAX_NAME_LENGTH-1] of Char;
    description:array[0..XA_DECODER_MAX_DESCRIPTION_LENGTH-1] of char;
  end;


  PXA_OutputFilter = ^TXA_OutputFilter;

  PXA_outputFilterNode=^TXA_outputFilterNode;
  TXA_outputFilterNode =record
    id:integer;
    instance : pointer;
    vtable : PXA_outputfilter;
    next,
    prev : PXA_outputfilternode;
  end;



  TXA_OutPutFilter = record
    filter_get_name : function : pchar;
    filter_new : function(filter:pointer;id:integer;decoder:PXA_decoderinfo):integer;
    filter_delete:function(filter:pointer):integer;
    output_open,
    output_close : function(node:PXA_OutputFilterNode):integer;
    output_write : function(node:PXA_Outputfilternode;buffer:pointer;size:longword;
                            bytes_per_sample,stereo,samplerate:integer):integer;
    output_get_buffer:procedure(node:PXA_OutputfilterNode;size:longword);
    output_get_control:function(node:PXA_Outputfilternode;control:PXA_outputcontrol;
                                flags:longword):integer;
    output_set_control:function(node:PXA_Outputfilternode;control:PXA_outputcontrol;
                                control_mask:longword):integer;
    output_get_status:function(node:PXA_outputfilternode;status:PXA_outputstatus):
                               integer;
    output_get_caps:function(node:PXA_outputfilternode):longword;
    output_send_message:function(node:PXA_outputfilternode;typ:integer;
                                 data:pointer;size:integer):integer;

  end;



  TXA_OutputModule = record
    output_module_probe : Function(name:pchar):integer;
    output_module_query : function(Query:TXA_OutputModuleQuery;Query_mask:Longword):integer;
    output_new : Function(output:pointer;name:pchar;class_info:PXA_OutputModuleClassInfo;
                          Decoder:PXA_DecoderInfo):integer;
    Output_delete:function(output:pointer):integer;
    Output_open:function(output:pointer):integer;
    output_write:function(output:pointer;buffer:pointer;size:longword;
                          bytes_per_sec,stereo,samplerate:integer):integer;
    output_get_buffer:procedure(output:pointer; size:longword);
    output_set_control:function(output:pointer;control:PXA_OutputControl;flags:longword):integer;
    output_get_control:function(output:pointer;control:PXA_outputcontrol;control_mask:longword):integer;
    output_get_status:function(output:pointer;status:PXA_OutputStatus):integer;
    output_get_caps:function(output:pointer):Longword;
    output_send_message:function(output:pointer;typ:integer;data:pointer;size:longword):integer;
  end;


  PXA_InputFilterNode = ^TXA_InputFilterNode;

  PXA_InputFilter = ^TXA_InputFilter;
  TXA_InputFilter = record
    filter_get_name:function : pchar;
    filter_new:function( filter:pointer;id:integer;decoder:PXA_Decoderinfo):integer;
    filter_delete:function(filter:pointer):integer;
    input_open ,
    input_close : function(node:PXA_InputFilterNode):integer;
    input_read : function(node:PXA_InputFilterNode;buffer:pointer;n:longword):integer;
    input_seek: function(node:PXA_InputFilterNode;offset:longword):integer;
    input_get_caps,
    input_get_size :function(node:PXA_InputFilterNode):longword;
    input_send_message:function(node:PXA_InputFilterNode;typ:integer;
                                data:pointer;size:longword):integer;
  end;

  TXA_InputFilterNode = record
    id:integer;
    instance:pointer;
    vtable : TXA_Inputfilter;
    next,
    prev   : PXA_InputfilterNode;
  end;


// -------

  TXA_DecoderCallbackTable = record
    Get_Environment_integer:function( Decoder:PXA_DecoderInfo;name:Pchar;value:Longword):integer;
    Get_Environment_string :function(Decoder:PXA_DecoderInfo;name,value:pchar):integer;
    Add_Environment_listener:function(Decoder:PXA_DecoderInfo;name:pchar;client:pointer;
                                      callback:TXA_EnvironmentCallback;handle:pointer):integer;
    Remove_environment_listener:function(Decoder:PXA_DecoderInfo;handle:pointer):integer;
  end;

  PXA_ModulesInfo=^TXA_ModulesInfo;
  TXA_ModulesInfo = record
    nb_input_modules,
    nb_output_modules : Integer;
  end;

  TXA_DecoderInfo = record
    Name : Pchar;
    Input : PXA_inputInfo;
    OutPut: PXA_outputInfo;
    modules:PXA_modulesinfo;
    status:PXA_statusinfo;
    output_buffer:PXA_outputbufferinfo;
    notification_client:TXA_NotificationClient;
    callbacks : TXA_DecoderCallbackTable;
    hidden : pointer;//PXA_DecoderPrivateInfo;
  end;

  PXA_EqualizerInfo = ^TXA_EqualizerInfo;
  TXA_EqualizerInfo = record
    left,
    right : array[0..XA_DECODER_EQUALIZER_NB_BANDS-1] of char;
  end;


  TFilters_List_Callback = procedure(client:pointer;node:PXA_InputfilterNode);

{-------------------------------------------------------------------------------
       xaudio generic functions
-------------------------------------------------------------------------------}
function xaudio_error_string(code:integer) : pchar;stdcall;external XADLL;
function xaudio_get_api_version(api_id:longword) : Longword;stdcall;external XADLL;


{-------------------------------------------------------------------------------
       decoder functions
-------------------------------------------------------------------------------}
  Function decoder_new(var decoder :PXA_DecoderInfo):integer;stdcall;external XADLL;
  Function decoder_decode(decoder:PXA_DecoderInfo;output_buffer:pointer):integer
                    stdcall;external XADLL;
  function decoder_play(decoder:PXA_Decoderinfo):integer;stdcall;external XADLL;
  function decoder_delete(decoder:PXA_DecoderInfo):integer;stdcall;external XADLL;
  function decoder_version(var major,minor,state:pchar) :pchar;stdcall;external XADLL;


  // decoder_input
  function decoder_input_open(Decoder:PXA_Decoderinfo):integer;stdcall;external XADLL;
  function decoder_input_close(Decoder:PXA_Decoderinfo):integer;stdcall;external XADLL;

  function decoder_input_delete(decoder:PXA_decoderinfo):integer;stdcall;external XADLL;

  function decoder_input_read(decoder:PXA_decoderinfo;buffer:pointer;size:integer):integer;
                        stdcall;external XADLL;

  function decoder_input_new(decoder:PXA_DecoderInfo;name:pchar;
                             module:integer):integer;stdcall;external XADLL;

  function decoder_input_module_register(decoder:PXA_DecoderInfo;const module:
                                         TXA_InputModule):integer; stdcall;external XADLL;

  function decoder_input_seek_to_offset(decoder:PXA_DecoderInfo;Offset:longword):integer;
                   stdcall;external XADLL;

  function decoder_input_module_query(decoder:PXA_Decoderinfo;module:integer;
                                      query:PXA_InputModuleQuery;qflags:longword):integer;
                                      stdcall;external XADLL;

  function decoder_input_add_filter(decoder:PXA_Decoderinfo;filer:PXA_Inputfilter;
                              where:integer):integer;stdcall;external XADLL;

  function decoder_input_remove_filter(decoder:PXA_decoderInfo;name:pchar;id:integer):
                                 integer;stdcall;external XADLL;

  function decoder_input_filters_list(decoder:PXA_DecoderInfo;client:pointer;
                                      callback:TFilters_List_Callback):integer;
                                      stdcall;external XADLL;

  function decoder_input_seek_to_position(decoder:PXA_Decoderinfo;position:single)
                                          :integer;stdcall;external XADLL;


  function decoder_input_seek_to_time(decoder:PXA_decoderinfo;seconds:single):integer;
                                      stdcall;external XADLL;
  function decoder_input_seek_to_timecode(decoder:PXA_decoderInfo;timecode:
                                      PXA_timecode):integer;stdcall;external XADLL;
  function decoder_input_send_message(Decoder:PXA_DecoderInfo;typ:integer;
                                      data:pointer;size:longword):integer;stdcall;
                                      external XADLL;


  // decoder_output
  function decoder_output_new(decoder:PXA_Decoderinfo;const name:pchar;module:integer):integer;
                              stdcall;external XADLL;
  function decoder_output_open(decoder:PXA_DecoderInfo):integer;stdcall;external XADLL;

  function decoder_output_module_register(decoder:PXA_decoderinfo;module:PXA_Outputmodule)
                                          :integer;stdcall;external XADLL;
  function decoder_output_module_query(decoder:PXA_decoderinfo;filter:PXA_outputfilter;
                                       name:pchar;id:integer):integer;stdcall;external XADLL;
  function decoder_output_add_filter(decoder:PXA_DecoderInfo;filter:PXA_outputfilter;
                                     where:integer):integer;stdcall;external XADLL;
  function decoder_output_remove_filter(decoder:PXA_decoderInfo;name:pchar;
                                        id:integer):integer;stdcall;external XADLL;
  function decoder_output_filters_list(decoder:PXA_DecoderInfo;client:pointer;
                                       callback:TFilters_list_callback):integer;
                                       stdcall;external XADLL;
  function decoder_output_delete(decoder:PXA_decoderinfo):integer;stdcall;
                                 external XADLL;
  function decoder_output_close(decoder:PXA_decoderinfo):integer;stdcall;
                                 external XADLL;
  function decoder_output_write(decoder:PXA_decoderinfo;buffeR:pointer;
                                size,bytes_per_sample,stereo,samplerate:longword)
                                :integer;stdcall;external XADLL;
  function decoder_output_set_control(decoder:pxa_decoderinfo;control:
                                      PXA_outputcontrol;flags:longword):integer;
                                      stdcall;external XADLL;
  function decoder_output_get_control(decoder:pxa_decoderinfo;control:PXA_outputcontrol;
                                      flags:longword):integer;stdcall;external XADLL;
  
  // decoder_codec_

  function decoder_codec_set_channels(decoder:PXA_decoderinfo;channels:
                                PXA_outputchannelsmode):integer;stdcall;external XADLL;
  function decoder_codec_get_channels(decoder:pxa_decoderinfo):integer;
                                      stdcall;external XADLL;
  function decoder_codec_set_quality(decoder:pxa_decoderinfo;quality:longword):integer
                                     stdcall;external XADLL;
  function decoder_codec_get_quality(decoder:pxa_decoderinfo):integer;stdcall;external XADLL;
  function decoder_codec_set_equalizer(decoder:pxa_decoderinfo;equalizer:
                                    PXA_Equalizerinfo):integer;stdcall;external XADLL;
  function decoder_codec_get_equalizer(decoder:pxa_decoderinfo;
                                    equalizer:PXA_Equalizerinfo):integer;stdcall;external XADLL;
  function decoder_codec_enable_feedback(decoder:pxa_decoderinfo):integer
                                    stdcall;external XADLL;
  function decoder_codec_disable_feedback(decoder:pxa_decoderinfo):integer
                                    stdcall;external XADLL;

  // decoder environment
  function decoder_set_environment_integer(decoder:PXA_decoderinfo;name:pchar;
                                           value:longword):integer;stdcall;external XADLL;
  function decoder_get_environment_integer(decoder:PXA_decoderinfo;name:pchar;
                                           value:longword):integer;stdcall;external XADLL;
  function decoder_set_environment_string(decoder:PXA_decoderinfo;name:pchar;
                                           value:pchar):integer;stdcall;external XADLL;
  function decoder_get_environment_string(decoder:PXA_decoderinfo;name:pchar;
                                           value:pchar):integer;stdcall;external XADLL;
  function decoder_unset_environment(decoder:pxa_decoderinfo;name:pchar):integer;
                                     stdcall;external XADLL;
  function decoder_add_environment_listener(decoder:PXA_decoderinfo;name:pchar;
                                            client:pointer;callback:TXA_EnvironmentCallback;
                                            handle:pointer):integer;stdcall;external XADLL;
  function decoder_remove_environment_listener(decoder:PXA_decoderinfo;handle:pointer):
                                       integer;stdcall;external XADLL;



implementation

end.

